var Fis26000_GmaIcmsSt_Controller = function(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {
    
    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
		    if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoGiaIcmsSt','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(spedWidget) {
        var downloadRoute;
        var fileName;
        
        if(spedWidget.hasCheckedRows()){
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoGiaIcmsSt','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };
          
    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarGia = function(giaicmsWidget) {
        if (giaicmsWidget.isValid()) {
            var row = giaicmsWidget.currentRow;
            var route = "fis#/exportarGiaIcmsSt";
            var message = Messages_fiscal.EXPORTANDO_GIA;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    
    /*
     * Função para alterar a propriedade readOnly dos campos de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function(giaicmsWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(giaicmsWidget);
        // Valida inscrição do substituto.
        this.inscricaoEstadualOnChange(giaicmsWidget);
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição do
     * substituto, conforme a inserção da inscrição estadual.
     */
    this.inscricaoEstadualOnChange = function(giaicmsWidget) {
        // Variável booleana que é setada como true caso alguma inscrição estadual
        // tenha sido selecionada.
        var inscricaoEstadualIsSelected = !!giaicmsWidget.currentRow.CDINSCESTA;
        var inscricaoSubstitutoField = giaicmsWidget.getField('CDINSCESTAST');
        var operacaoField = giaicmsWidget.getField('OPTRANSFER');
        var versaoField = giaicmsWidget.getField('VERSAO');

        // Altera as propriedades do field de inscrição do substituto e
        // reseta seu valor.
        inscricaoSubstitutoField.readOnly = !inscricaoEstadualIsSelected;
        inscricaoSubstitutoField.setValue(null);
        inscricaoSubstitutoField.needReload = true;
        versaoField.readOnly = !inscricaoEstadualIsSelected;
        versaoField.setValue(null);
        operacaoField.readOnly = !inscricaoEstadualIsSelected;
        operacaoField.hideEmptyValue = inscricaoEstadualIsSelected;
        giaicmsWidget.currentRow.OPTRANSFER = "";
        if(inscricaoEstadualIsSelected){
            this.findLastRowData(giaicmsWidget.name, giaicmsWidget.currentRow);
        }
    };
    
    this.findLastRowData = function(widgetName, row){
        ObrigacoesAcessoriasUtil.findLastRowData(widgetName, row).then(function(response){
            var lastRowData = response.dataset.columnsToReturn.lastRowData;
            if(lastRowData.length > 0){
                row.OPTRANSFER = lastRowData[0].OPTRANSFER;
                row.VERSAO = lastRowData[0].VERSAO;
            }
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis26000_GmaIcmsSt_Controller', Fis26000_GmaIcmsSt_Controller);
});